diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/wifi-phy.h ns-3.31/src/wifi/model/wifi-phy.h
--- ns-3.30.1/src/wifi/model/wifi-phy.h	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wifi/model/wifi-phy.h	2020-06-27 17:38:30.000000000 -0700
@@ -1727,24 +1862,23 @@
   void MaybeCcaBusyDuration (void);
 
   /**
-   * Starting receiving the packet after having detected the medium is idle or after a reception switch.
+   * Starting receiving the PPDU after having detected the medium is idle or after a reception switch.
    *
-   * \param event the corresponding event of the first time the packet arrives (also storing packet and TxVector information)
+   * \param event the event holding incoming PPDU's information
    * \param rxPowerW the receive power in W
-   * \param rxDuration the duration needed for the reception of the packet
    */
-  void StartRx (Ptr<Event> event, double rxPowerW, Time rxDuration);
+  void StartRx (Ptr<Event> event, double rxPowerW);
   /**
    * Get the reception status for the provided MPDU and notify.
    *
-   * \param mpdu the arriving MPDU
-   * \param event the corresponding event of the first time the packet arrives (also storing packet and TxVector information)
+   * \param psdu the arriving MPDU formatted as a PSDU
+   * \param event the event holding incoming PPDU's information
    * \param relativeMpduStart the relative start time of the MPDU within the A-MPDU. 0 for normal MPDUs
    * \param mpduDuration the duration of the MPDU
    *
    * \return information on MPDU reception: status, signal power (dBm), and noise power (in dBm)
    */
-  std::pair<bool, SignalNoiseDbm> GetReceptionStatus (Ptr<const Packet> mpdu,
+  std::pair<bool, SignalNoiseDbm> GetReceptionStatus (Ptr<const WifiPsdu> psdu,
                                                       Ptr<Event> event,
                                                       Time relativeMpduStart,
                                                       Time mpduDuration);
@@ -1756,6 +1890,13 @@
    * \see class CallBackTraceSource
    */
   TracedCallback<Ptr<const Packet>, double > m_phyTxBeginTrace;
+  /**
+   * The trace source fired when a PSDU begins the transmission process on
+   * the medium.
+   *
+   * \see class CallBackTraceSource
+   */
+  TracedCallback<Ptr<const WifiPsdu>, WifiTxVector, double /* TX power (W) */> m_phyTxPsduBeginTrace;
 
   /**
    * The trace source fired when a packet ends the transmission process on
@@ -1766,7 +1907,7 @@
   TracedCallback<Ptr<const Packet> > m_phyTxEndTrace;
 
   /**
-   * The trace source fired when the phy layer drops a packet as it tries
+   * The trace source fired when the PHY layer drops a packet as it tries
    * to transmit it.
    *
    * \see class CallBackTraceSource
@@ -1782,6 +1923,22 @@
   TracedCallback<Ptr<const Packet> > m_phyRxBeginTrace;
 
   /**
+   * The trace source fired when the reception of the PHY payload (PSDU) begins.
+   *
+   * This traced callback models the behavior of the PHY-RXSTART
+   * primitive which is launched upon correct decoding of
+   * the PHY header and support of modes within.
+   * We thus assume that it is sent just before starting
+   * the decoding of the payload, since it's there that
+   * support of the header's content is checked. In addition,
+   * it's also at that point that the correct decoding of
+   * HT-SIG, VHT-SIGs, and HE-SIGs are checked.
+   *
+   * \see class CallBackTraceSource
+   */
+  TracedCallback<WifiTxVector, Time> m_phyRxPayloadBeginTrace;
+
+  /**
    * The trace source fired when a packet ends the reception process from
    * the medium.
    *
@@ -1790,14 +1947,14 @@
   TracedCallback<Ptr<const Packet> > m_phyRxEndTrace;
 
   /**
-   * The trace source fired when the phy layer drops a packet it has received.
+   * The trace source fired when the PHY layer drops a packet it has received.
    *
    * \see class CallBackTraceSource
    */
   TracedCallback<Ptr<const Packet>, WifiPhyRxfailureReason > m_phyRxDropTrace;
 
   /**
-   * A trace source that emulates a wifi device in monitor mode
+   * A trace source that emulates a Wi-Fi device in monitor mode
    * sniffing a packet being received.
    *
    * As a reference with the real world, firing this trace
@@ -1806,12 +1963,12 @@
    *
    * \see class CallBackTraceSource
    * \todo WifiTxVector and signalNoiseDbm should be be passed as
-   * const  references because of their sizes.
+   *       const references because of their sizes.
    */
   TracedCallback<Ptr<const Packet>, uint16_t, WifiTxVector, MpduInfo, SignalNoiseDbm> m_phyMonitorSniffRxTrace;
 
   /**
-   * A trace source that emulates a wifi device in monitor mode
+   * A trace source that emulates a Wi-Fi device in monitor mode
    * sniffing a packet being transmitted.
    *
    * As a reference with the real world, firing this trace
@@ -1825,7 +1982,7 @@
   TracedCallback<Ptr<const Packet>, uint16_t, WifiTxVector, MpduInfo> m_phyMonitorSniffTxTrace;
 
   /**
-   * A trace source that indiates the end of both HE SIG fields as well as training fields for received 802.11ax packets
+   * A trace source that indicates the end of both HE SIG fields as well as training fields for received 802.11ax packets
    *
    * \see class CallBackTraceSource
    */
@@ -1869,15 +2026,17 @@
    */
   WifiModeList m_deviceRateSet;
   WifiModeList m_deviceMcsSet; //!< the device MCS set
+  /// Maps MCS values to indices in m_deviceMcsSet, for HT, VHT and HE modulation classes
+  std::map<WifiModulationClass, std::map<uint8_t /* MCS value */, uint8_t /* index */>> m_mcsIndexMap;
 
   std::vector<uint8_t> m_bssMembershipSelectorSet; //!< the BSS membership selector set
 
   WifiPhyStandard m_standard;               //!< WifiPhyStandard
   bool m_isConstructed;                     //!< true when ready to set frequency
   uint16_t m_channelCenterFrequency;        //!< Center frequency in MHz
-  uint16_t m_initialFrequency;              //!< Store frequency until initialization
+  uint16_t m_initialFrequency;              //!< Store frequency until initialization (MHz)
   bool m_frequencyChannelNumberInitialized; //!< Store initialization state
-  uint16_t m_channelWidth;                  //!< Channel width
+  uint16_t m_channelWidth;                  //!< Channel width (MHz)
 
   double   m_rxSensitivityW;      //!< Receive sensitivity threshold in watts
   double   m_ccaEdThresholdW;     //!< Clear channel assessment (CCA) threshold in watts
@@ -1887,14 +2046,14 @@
   double   m_txPowerEndDbm;       //!< Maximum transmission power (dBm)
   uint8_t  m_nTxPower;            //!< Number of available transmission power levels
 
-  bool m_powerRestricted;  //!< Flag whether transmit power is retricted by OBSS PD SR
-  double m_txPowerMaxSiso; //!< SISO maximum transmit power due to OBSS PD SR power restriction
-  double m_txPowerMaxMimo; //!< MIMO maximum transmit power due to OBSS PD SR power restriction
-  bool m_channelAccessRequested;
+  bool m_powerRestricted;        //!< Flag whether transmit power is restricted by OBSS PD SR
+  double m_txPowerMaxSiso;       //!< SISO maximum transmit power due to OBSS PD SR power restriction (dBm)
+  double m_txPowerMaxMimo;       //!< MIMO maximum transmit power due to OBSS PD SR power restriction (dBm)
+  bool m_channelAccessRequested; //!< Flag if channels access has been requested (used for OBSS_PD SR)
 
   bool     m_greenfield;         //!< Flag if GreenField format is supported (deprecated)
   bool     m_shortGuardInterval; //!< Flag if HT/VHT short guard interval is supported (deprecated)
-  bool     m_shortPreamble;      //!< Flag if short PLCP preamble is supported
+  bool     m_shortPreamble;      //!< Flag if short PHY preamble is supported
 
   Time m_guardInterval; //!< Supported HE guard interval (deprecated)
 
@@ -1903,36 +2062,27 @@
   uint8_t m_rxSpatialStreams;  //!< Number of supported RX spatial streams
 
   typedef std::map<ChannelNumberStandardPair,FrequencyWidthPair> ChannelToFrequencyWidthMap; //!< channel to frequency width map typedef
-  static ChannelToFrequencyWidthMap m_channelToFrequencyWidth; //!< the channel to frequency width map
+  static ChannelToFrequencyWidthMap m_channelToFrequencyWidth;                               //!< the channel to frequency width map
 
-  std::vector<uint16_t> m_supportedChannelWidthSet; //!< Supported channel width
+  std::vector<uint16_t> m_supportedChannelWidthSet; //!< Supported channel width set (MHz)
   uint8_t               m_channelNumber;            //!< Operating channel number
   uint8_t               m_initialChannelNumber;     //!< Initial channel number
 
   Time m_channelSwitchDelay;     //!< Time required to switch between channel
-  uint32_t m_totalAmpduSize;     //!< Total size of the previously transmitted MPDUs in an A-MPDU, used for the computation of the number of symbols needed for the last MPDU in the A-MPDU
-  double m_totalAmpduNumSymbols; //!< Number of symbols previously transmitted for the MPDUs in an A-MPDU, used for the computation of the number of symbols needed for the last MPDU in the A-MPDU
 
   Ptr<NetDevice>     m_device;   //!< Pointer to the device
   Ptr<MobilityModel> m_mobility; //!< Pointer to the mobility model
 
-  Ptr<Event> m_currentEvent; //!< Hold the current event
-  Ptr<FrameCaptureModel> m_frameCaptureModel; //!< Frame capture model
+  Ptr<Event> m_currentEvent;                            //!< Hold the current event
+  Ptr<FrameCaptureModel> m_frameCaptureModel;           //!< Frame capture model
   Ptr<PreambleDetectionModel> m_preambleDetectionModel; //!< Preamble detection model
-  Ptr<WifiRadioEnergyModel> m_wifiRadioEnergyModel; //!< Wifi radio energy model
-  Ptr<ErrorModel> m_postReceptionErrorModel; //!< Error model for receive packet events
-  Time m_timeLastPreambleDetected; //!< Record the time the last preamble was detected
+  Ptr<WifiRadioEnergyModel> m_wifiRadioEnergyModel;     //!< Wifi radio energy model
+  Ptr<ErrorModel> m_postReceptionErrorModel;            //!< Error model for receive packet events
+  Time m_timeLastPreambleDetected;                      //!< Record the time the last preamble was detected
 
-  Callback<void> m_capabilitiesChangedCallback; //!< Callback when PHY capabilities changed
+  Callback<void> m_capabilitiesChangedCallback;         //!< Callback when PHY capabilities changed
 };
 
-/**
- * \param os          output stream
- * \param state       wifi state to stringify
- * \return output stream
- */
-std::ostream& operator<< (std::ostream& os, WifiPhyState state);
-
 } //namespace ns3
 
 #endif /* WIFI_PHY_H */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/wifi-phy-header.h ns-3.31/src/wifi/model/wifi-phy-header.h
--- ns-3.30.1/src/wifi/model/wifi-phy-header.h	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wifi/model/wifi-phy-header.h	2020-06-27 17:38:30.000000000 -0700
@@ -107,11 +107,13 @@
    * Fill the RATE field of L-SIG (in bit/s).
    *
    * \param rate the RATE field of L-SIG expressed in bit/s
+   * \param channelWidth the channel width (in MHz)
    */
   void SetRate (uint64_t rate, uint16_t channelWidth = 20);
   /**
    * Return the RATE field of L-SIG (in bit/s).
    *
+   * \param channelWidth the channel width (in MHz)
    * \return the RATE field of L-SIG expressed in bit/s
    */
   uint64_t GetRate (uint16_t channelWidth = 20) const;
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/wifi-phy-listener.h ns-3.31/src/wifi/model/wifi-phy-listener.h
--- ns-3.30.1/src/wifi/model/wifi-phy-listener.h	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wifi/model/wifi-phy-listener.h	2020-06-27 17:38:30.000000000 -0700
@@ -27,7 +27,7 @@
 class Time;
 
 /**
- * \brief receive notifications about phy events.
+ * \brief receive notifications about PHY events.
  */
 class WifiPhyListener
 {
@@ -67,13 +67,13 @@
   virtual void NotifyRxEndError (void) = 0;
   /**
    * \param duration the expected transmission duration.
-   * \param txPowerDbm the nominal tx power in dBm
+   * \param txPowerDbm the nominal TX power in dBm
    *
    * We are about to send the first bit of the packet.
    * We do not send any event to notify the end of
    * transmission. Listeners should assume that the
    * channel implicitly reverts to the idle state
-   * unless they have received a cca busy report.
+   * unless they have received a CCA busy report.
    */
   virtual void NotifyTxStart (Time duration, double txPowerDbm) = 0;
   /**
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/wifi-phy-state.h ns-3.31/src/wifi/model/wifi-phy-state.h
--- ns-3.30.1/src/wifi/model/wifi-phy-state.h	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wifi/model/wifi-phy-state.h	2020-06-27 17:38:30.000000000 -0700
@@ -22,6 +22,8 @@
 #ifndef WIFI_PHY_STATE_H
 #define WIFI_PHY_STATE_H
 
+#include "ns3/fatal-error.h"
+
 /**
   * The state of the PHY layer.
   */
@@ -58,4 +60,35 @@
   OFF
 };
 
+/**
+* \brief Stream insertion operator.
+*
+* \param os the stream
+* \param state the state
+* \returns a reference to the stream
+*/
+inline std::ostream& operator<< (std::ostream& os, WifiPhyState state)
+{
+  switch (state)
+    {
+    case IDLE:
+      return (os << "IDLE");
+    case CCA_BUSY:
+      return (os << "CCA_BUSY");
+    case TX:
+      return (os << "TX");
+    case RX:
+      return (os << "RX");
+    case SWITCHING:
+      return (os << "SWITCHING");
+    case SLEEP:
+      return (os << "SLEEP");
+    case OFF:
+      return (os << "OFF");
+    default:
+      NS_FATAL_ERROR ("Invalid state");
+      return (os << "INVALID");
+    }
+}
+
 #endif /* WIFI_PHY_STATE_H */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/wifi-phy-state-helper.cc ns-3.31/src/wifi/model/wifi-phy-state-helper.cc
--- ns-3.30.1/src/wifi/model/wifi-phy-state-helper.cc	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wifi/model/wifi-phy-state-helper.cc	2020-06-27 17:38:30.000000000 -0700
@@ -25,6 +25,7 @@
 #include "wifi-phy-state-helper.h"
 #include "wifi-tx-vector.h"
 #include "wifi-phy-listener.h"
+#include "wifi-psdu.h"
 
 namespace ns3 {
 
@@ -165,14 +166,8 @@
       retval = m_endSwitching - Simulator::Now ();
       break;
     case WifiPhyState::IDLE:
-      retval = Seconds (0);
-      break;
     case WifiPhyState::SLEEP:
-      NS_FATAL_ERROR ("Cannot determine when the device will wake up.");
-      retval = Seconds (0);
-      break;
     case WifiPhyState::OFF:
-      NS_FATAL_ERROR ("Cannot determine when the device will be switched on.");
       retval = Seconds (0);
       break;
     default:
@@ -190,6 +185,12 @@
   return m_startRx;
 }
 
+Time
+WifiPhyStateHelper::GetLastRxEndTime (void) const
+{
+  return m_endRx;
+}
+
 WifiPhyState
 WifiPhyStateHelper::GetState (void) const
 {
@@ -339,9 +340,17 @@
       Time ccaBusyStart = Max (m_endTx, m_endRx);
       ccaBusyStart = Max (ccaBusyStart, m_startCcaBusy);
       ccaBusyStart = Max (ccaBusyStart, m_endSwitching);
-      m_stateLogger (ccaBusyStart, idleStart - ccaBusyStart, WifiPhyState::CCA_BUSY);
+      Time ccaBusyDuration = idleStart - ccaBusyStart;
+      if (ccaBusyDuration.IsStrictlyPositive ())
+        {
+          m_stateLogger (ccaBusyStart, ccaBusyDuration, WifiPhyState::CCA_BUSY);
+        }
+    }
+  Time idleDuration = now - idleStart;
+  if (idleDuration.IsStrictlyPositive ())
+    {
+      m_stateLogger (idleStart, idleDuration, WifiPhyState::IDLE);
     }
-  m_stateLogger (idleStart, now - idleStart, WifiPhyState::IDLE);
 }
 
 void
@@ -453,33 +462,33 @@
 }
 
 void
-WifiPhyStateHelper::SwitchFromRxEndOk (Ptr<Packet> packet, double snr, WifiTxVector txVector, std::vector<bool> statusPerMpdu)
+WifiPhyStateHelper::SwitchFromRxEndOk (Ptr<WifiPsdu> psdu, double snr, WifiTxVector txVector, std::vector<bool> statusPerMpdu)
 {
-  NS_LOG_FUNCTION (this << packet << snr << txVector << statusPerMpdu.size () <<
+  NS_LOG_FUNCTION (this << *psdu << snr << txVector << statusPerMpdu.size () <<
                    std::all_of(statusPerMpdu.begin(), statusPerMpdu.end(), [](bool v) { return v; })); //returns true if all true
   NS_ASSERT (statusPerMpdu.size () != 0);
   NS_ASSERT (m_endRx == Simulator::Now ());
-  m_rxOkTrace (packet, snr, txVector.GetMode (), txVector.GetPreambleType ());
+  m_rxOkTrace (psdu->GetPacket (), snr, txVector.GetMode (), txVector.GetPreambleType ());
   NotifyRxEndOk ();
   DoSwitchFromRx ();
   if (!m_rxOkCallback.IsNull ())
     {
-      m_rxOkCallback (packet, snr, txVector, statusPerMpdu);
+      m_rxOkCallback (psdu, snr, txVector, statusPerMpdu);
     }
 
 }
 
 void
-WifiPhyStateHelper::SwitchFromRxEndError (Ptr<Packet> packet, double snr)
+WifiPhyStateHelper::SwitchFromRxEndError (Ptr<WifiPsdu> psdu, double snr)
 {
-  NS_LOG_FUNCTION (this << packet << snr);
+  NS_LOG_FUNCTION (this << *psdu << snr);
   NS_ASSERT (m_endRx == Simulator::Now ());
-  m_rxErrorTrace (packet, snr);
+  m_rxErrorTrace (psdu->GetPacket (), snr);
   NotifyRxEndError ();
   DoSwitchFromRx ();
   if (!m_rxErrorCallback.IsNull ())
     {
-      m_rxErrorCallback (packet);
+      m_rxErrorCallback (psdu);
     }
 }
 
@@ -503,7 +512,6 @@
       NotifyMaybeCcaBusyStart (duration);
     }
   Time now = Simulator::Now ();
-  m_endCcaBusy = std::max (m_endCcaBusy, now + duration);
   switch (GetState ())
     {
     case WifiPhyState::IDLE:
@@ -518,7 +526,7 @@
     {
       m_startCcaBusy = now;
     }
-  m_stateLogger (now, duration, WifiPhyState::CCA_BUSY);
+  m_endCcaBusy = std::max (m_endCcaBusy, now + duration);
 }
 
 void
@@ -568,20 +576,15 @@
 }
 
 void
-WifiPhyStateHelper::SwitchFromRxAbort (bool failure)
+WifiPhyStateHelper::SwitchFromRxAbort (void)
 {
   NS_LOG_FUNCTION (this);
   NS_ASSERT (IsStateRx ());
-  if (failure)
-    {
-      NotifyRxEndError ();
-    }
-  else
-    {
-      NotifyRxEndOk ();
-    }
+  NotifyRxEndOk ();
   DoSwitchFromRx ();
-  NS_ASSERT (!IsStateRx ());
+  m_endCcaBusy = Simulator::Now ();
+  NotifyMaybeCcaBusyStart (Seconds (0));
+  NS_ASSERT (IsStateIdle ());
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/wifi-phy-state-helper.h ns-3.31/src/wifi/model/wifi-phy-state-helper.h
--- ns-3.30.1/src/wifi/model/wifi-phy-state-helper.h	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wifi/model/wifi-phy-state-helper.h	2020-06-27 17:38:30.000000000 -0700
@@ -34,24 +34,25 @@
 class WifiTxVector;
 class WifiMode;
 class Packet;
+class WifiPsdu;
 
 /**
- * Callback if packet successfully received (i.e. if aggregate,
+ * Callback if PSDU successfully received (i.e. if aggregate,
  * it means that at least one MPDU of the A-MPDU was received,
  * considering that the per-MPDU reception status is also provided).
  *
- * arg1: packet received successfully
- * arg2: SNR of packet
- * arg3: TXVECTOR of packet
+ * arg1: PSDU received successfully
+ * arg2: SNR of PSDU in linear scale
+ * arg3: TXVECTOR of PSDU
  * arg4: vector of per-MPDU status of reception.
  */
-typedef Callback<void, Ptr<Packet>, double, WifiTxVector, std::vector<bool>> RxOkCallback;
+typedef Callback<void, Ptr<WifiPsdu>, double, WifiTxVector, std::vector<bool>> RxOkCallback;
 /**
- * Callback if packet unsuccessfully received
+ * Callback if PSDU unsuccessfully received
  *
- * arg1: packet received unsuccessfully
+ * arg1: PSDU received unsuccessfully
  */
-typedef Callback<void, Ptr<Packet>> RxErrorCallback;
+typedef Callback<void, Ptr<WifiPsdu>> RxErrorCallback;
 
 /**
  * \ingroup wifi
@@ -72,25 +73,25 @@
   /**
    * Set a callback for a successful reception.
    *
-   * \param callback
+   * \param callback the RxOkCallback to set
    */
   void SetReceiveOkCallback (RxOkCallback callback);
   /**
    * Set a callback for a failed reception.
    *
-   * \param callback
+   * \param callback the RxErrorCallback to set
    */
   void SetReceiveErrorCallback (RxErrorCallback callback);
   /**
    * Register WifiPhyListener to this WifiPhyStateHelper.
    *
-   * \param listener
+   * \param listener the WifiPhyListener to register
    */
   void RegisterListener (WifiPhyListener *listener);
   /**
    * Remove WifiPhyListener from this WifiPhyStateHelper.
    *
-   * \param listener
+   * \param listener the WifiPhyListener to unregister
    */
   void UnregisterListener (WifiPhyListener *listener);
   /**
@@ -153,14 +154,20 @@
    * \return the time the last RX start.
    */
   Time GetLastRxStartTime (void) const;
+  /**
+   * Return the time the last RX end.
+   *
+   * \return the time the last RX end.
+   */
+  Time GetLastRxEndTime (void) const;
 
   /**
    * Switch state to TX for the given duration.
    *
    * \param txDuration the duration of the TX
    * \param packet the packet
-   * \param txPowerDbm the nominal tx power in dBm
-   * \param txVector the tx vector of the packet
+   * \param txPowerDbm the nominal TX power in dBm
+   * \param txVector the TX vector of the packet
    */
   void SwitchToTx (Time txDuration, Ptr<const Packet> packet, double txPowerDbm, WifiTxVector txVector);
   /**
@@ -178,19 +185,19 @@
   /**
    * Switch from RX after the reception was successful.
    *
-   * \param packet the successfully received packet
-   * \param snr the SNR of the received packet
-   * \param txVector TXVECTOR of the packet
+   * \param psdu the successfully received PSDU
+   * \param snr the SNR of the received PSDU in linear scale
+   * \param txVector TXVECTOR of the PSDU
    * \param statusPerMpdu reception status per MPDU
    */
-  void SwitchFromRxEndOk (Ptr<Packet> packet, double snr, WifiTxVector txVector, std::vector<bool> statusPerMpdu);
+  void SwitchFromRxEndOk (Ptr<WifiPsdu> psdu, double snr, WifiTxVector txVector, std::vector<bool> statusPerMpdu);
   /**
    * Switch from RX after the reception failed.
    *
-   * \param packet the packet that we failed to received
-   * \param snr the SNR of the received packet
+   * \param psdu the PSDU that we failed to received
+   * \param snr the SNR of the received PSDU in linear scale
    */
-  void SwitchFromRxEndError (Ptr<Packet> packet, double snr);
+  void SwitchFromRxEndError (Ptr<WifiPsdu> psdu, double snr);
   /**
    * Switch to CCA busy.
    *
@@ -209,10 +216,8 @@
   void SwitchFromSleep (Time duration);
   /**
    * Abort current reception
-   *
-   * \param failure flag to indicate whether RX abortion is due to a failure
    */
-  void SwitchFromRxAbort (bool failure);
+  void SwitchFromRxAbort (void);
   /**
    * Switch to off mode.
    */
@@ -227,18 +232,18 @@
   /**
    * TracedCallback signature for state changes.
    *
-   * \param [in] start Time when the \p state started.
+   * \param [in] start Time when the \pname{state} started.
    * \param [in] duration Amount of time we've been in (or will be in)
-   *             the \p state.
+   *             the \pname{state}.
    * \param [in] state The state.
    */
   typedef void (* StateTracedCallback)(Time start, Time duration, WifiPhyState state);
 
   /**
-   * TracedCallback signature for receive end ok event.
+   * TracedCallback signature for receive end OK event.
    *
    * \param [in] packet The received packet.
-   * \param [in] snr    The SNR of the received packet.
+   * \param [in] snr    The SNR of the received packet in linear scale.
    * \param [in] mode   The transmission mode of the packet.
    * \param [in] preamble The preamble of the packet.
    */
@@ -248,7 +253,7 @@
    * TracedCallback signature for receive end error event.
    *
    * \param [in] packet       The received packet.
-   * \param [in] snr          The SNR of the received packet.
+   * \param [in] snr          The SNR of the received packet in linear scale.
    */
   typedef void (* RxEndErrorTracedCallback)(Ptr<const Packet> packet, double snr);
 
@@ -283,7 +288,7 @@
    * Notify all WifiPhyListener that the transmission has started for the given duration.
    *
    * \param duration the duration of the transmission
-   * \param txPowerDbm the nominal tx power in dBm
+   * \param txPowerDbm the nominal TX power in dBm
    */
   void NotifyTxStart (Time duration, double txPowerDbm);
   /**
@@ -343,7 +348,7 @@
   bool m_isOff; ///< switched off
   Time m_endTx; ///< end transmit
   Time m_endRx; ///< end receive
-  Time m_endCcaBusy; ///< endn CCA busy
+  Time m_endCcaBusy; ///< end CCA busy
   Time m_endSwitching; ///< end switching
   Time m_startTx; ///< start transmit
   Time m_startRx; ///< start receive
